SystemOrganization addCategory: #'Rizel-Holmes'!

MBuilder subclass: #RzHolmes
	instanceVariableNames: 'versions tests packageRegex packageCachePath'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Rizel-Holmes'!

!RzHolmes class methodsFor: 'nil' stamp: 'JuanPabloSandovalA 6/24/2012 22:00'!
versions: versions packagesMatching: reges cache: path
	|instance|
	instance := self new.
	instance versions: versions.
	instance packageRegex: reges.
	instance packageCachePath: path.
	^ instance.! !

!RzHolmes methodsFor: 'hook' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 01:10'!
buildSuite
	| packages classes suite |
	suite := TestSuite named: 'RzHolmes'.
	packages := PackageInfo allPackages
				select: [:p | packageRegex match: p packageName].
	classes := OrderedCollection new.
	packages
		do: [:p | classes
				addAll: (p classes
						select: [:cls | ([cls new]
								on: Error
								do: [false])
								isKindOf: TestCase])].
	classes do: [:cls | suite addTest: (cls suite)].
	^ suite.! !

!RzHolmes methodsFor: 'hook' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 00:53'!
execute
	^ super
				execute: [:version | 
					| profile testSuite |
					self load: version fromPackageCache: self packageCachePath.
					testSuite := self buildSuite.
					profile := self
								profile: [testSuite run]
								inPackagesMatching: self packageRegex.
					profile unitTestResult: testSuite run.
					profile].! !

!RzHolmes methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 22:01'!
inPackagesMatching: anObject

	packageRegex := anObject! !

!RzHolmes methodsFor: 'initialize-release' stamp: 'JuanPabloSandovalA 6/24/2012 21:40'!
initialize
	""
	super initialize.
	versions := OrderedCollection new.
	! !

!RzHolmes methodsFor: 'hook' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 00:55'!
merge: result 
	| vs merges last |
	vs := versions asSortedCollection.
	last := nil.
	merges := OrderedCollection new.
	vs
		do: [:version | 
			| current merge |
			current := result at: version.
			current ifNotNil:[
				last
					ifNotNil: [merge := RzMerge
									packages: (self merge: last with: current).
						merge key: version versionNumber.
						merges add: merge].
				last := current]].
	^ merges! !

!RzHolmes methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 21:49'!
packageCachePath

	^ packageCachePath! !

!RzHolmes methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 21:49'!
packageCachePath: anObject

	packageCachePath := anObject! !

!RzHolmes methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 21:42'!
packageRegex

	^ packageRegex! !

!RzHolmes methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 21:42'!
packageRegex: anObject

	packageRegex := anObject! !

!RzHolmes methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/24/2012 21:42'!
versions

	^ versions! !

!RzHolmes methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 01:09'!
versions: aCollection 
	versions := aCollection.
	super
		define: #input
		named: #versions
		with: aCollection! !

MBuilder subclass: #RzHolmesDemo
	instanceVariableNames: ''
	classVariableNames: 'cache'
	poolDictionaries: ''
	category: 'Rizel-Holmes'!

!RzHolmesDemo class methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 00:02'!
cache
	^ cache.! !

!RzHolmesDemo class methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 00:02'!
cache: aObject
	^ cache :=aObject! !

!RzHolmesDemo methodsFor: 'demo' stamp: 'JuanPabloSandovalAlcocer 6/25/2012 01:05'!
run
	| rizel |
	rizel := RzHolmes new.
	rizel versions: (ConfigurationOfRoassal project versions asSortedCollection reverse).
	rizel packageCachePath: '/Users/juampi/workspace/Pharo-1.4/package-cache/'.
	rizel packageRegex: 'Roassal*'.
	self class cache
		ifNil: [self class cache: rizel execute].
	^ rizel merge: self class cache! !
